flash-kernel (3.109ubuntu6) questing; urgency=medium

  * Add entry for StarFive VisionFive 2 Lite (LP: #2121220)

 -- Dave Jones <dave.jones@canonical.com>  Sun, 24 Aug 2025 21:51:02 +0100

flash-kernel (3.109ubuntu5) questing; urgency=medium

  [ Tobias Heider ]
  * Add new T14s model names for LCD/OLED split
  * Add Acer Swift 14 AI

  [ Aleksandrs Vinarskis ]
  * Add Asus Zenbook A14
  * Add Dell Inspiron 14 Plus 7441
  * Add Dell Latitude 7455
  * Add new Asus Zenbook A14 model names for LCD/OLED split

 -- Tobias Heider <tobias.heider@canonical.com>  Wed, 13 Aug 2025 11:30:26 +0200

flash-kernel (3.109ubuntu4) questing; urgency=medium

  * Enable the hardware watchdog during migration of the boot configuration
    (LP: #2120177)
  * Report failure of new boot assets in motd (LP: #2119659)

 -- Dave Jones <dave.jones@canonical.com>  Fri, 08 Aug 2025 14:48:45 +0100

flash-kernel (3.109ubuntu3) questing; urgency=medium

  * Implement an A/B boot mechanism for the Raspberry Pi. This adds the new
    flash-kernel-piboot package, which contains the new piboot-try-reboot and
    piboot-try-validate services (LP: #2116266)

 -- Dave Jones <dave.jones@canonical.com>  Wed, 09 Jul 2025 14:35:09 +0100

flash-kernel (3.109ubuntu2) questing; urgency=medium

  [ Heinrich Schuchardt ]
  * db/all.db: Add entry for DeepComputing FML13V03 (LP: #2116161)

 -- Dave Jones <dave.jones@canonical.com>  Tue, 08 Jul 2025 14:17:18 +0100

flash-kernel (3.109ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2109835). Remaining changes:
    - Add support for Raspberry Pi 2, 3, 3+, CM3, CM3+, and 4 using a
      unified bootscript (replaces upstream's entries)
      + Update pi bootscript to support all flash-kernel vars, including
        calculated devtype and partition for future USB boot support
      + Add entry for Raspberry Pi 3A+
      + Add entry for Raspberry Pi CM4
      + Add entry for Raspberry Pi 400
      + Import UC20 updates to the rpi bootscript from the snappy-dev/image
        PPA
    - Add Kernel-Flavors check to Raspberry Pi entries
      + Support "raspi" kernel flavor
    - use umount -l in the cleanup function, else we fail while finishing up
      with the script
    - add a diversion for update-initramfs to live-installers
      post-base-installer.d to avoid update-initramfs runs before flash-kernel
      is configured
    - add a check for the diverted update-initramfs to flash-kernel-installer,
      so it gets reverted before we try to call update-initramfs
    - make post-base-installer.d/01flash-kernel-diversion actually an
      executable shell script
    - make sure that /dev is bind mounted in /target when running
      update-initramfs from flash-kernel-installer, else we do not find the
      boot media (this is only a workaround, actual fixing of the netinst
      environment is needed to fix this properly)
    - drop the "|| true" from the initramfs building code, if we fail here we
      actually dont want to attempt to flash that
    - Do not run flash-kernel inside an LXC container
    - Migrate default /etc/default/flash-kernel content to new default without
      asking via debconf
    - Filter the selection of 'latest' usable kernel through the whitelist.
    - Do not fail if there are no specified Kernel-Flavors for this machine.
    - flash-kernel/functions: Stop attempting to install the latest kernel
      if we request an older version, just refuse to act without --force.
    - Look for dtbs in /lib/firmware/$kvers/device-tree/ in find_dtb_file()
    - Allow us to find DTBs in both the old flat layout and the new vendor
      subdirectory layout, so we keep backward compatibility
    - Add support for gzip-compressed kernel images
    - Fix mkimage_kernel tests
    - Add tests for android-related functions
    - Add "pi" value for the "Method" field which copies all dtbs and
      overlays to the boot partition and provides defaults for the boot
      paths of the kernel, initrd, and u-boot script.
      + This fixes upgrades to support the Pi 4 on Bionic
      + Permit initrd to be missing in flash-kernel
      + Make U-boot optional in the "pi" method. From Groovy onwards, U-Boot
        will be an option in the boot chain but not activated by default.
        For the time being, the U-Boot-Script-Name will remain in the Pi
        entries, but this commit permits it to be blank in future.
      + Copy the Pi's bootloader firmware. At present, the Pi's bootloader
        firmware is being copied to the boot partition by the postinst of
        the linux-firmware-raspi2 package. However, flash-kernel should be
        responsible for copying *everything* necessary to boot the Linux
        kernel, hence this responsibility should be transferred to
        flash-kernel.
    - Ensure tests work independently of sort implementation
    - Always run flash-kernel on install/upgrade
    - Add pattern matching for machines
      + A requirement has come up to permit a simple form of pattern matching
        (specifically shell-style globbing) in the Machine field of the
        database. This commit implements this via a "case" match.
    - Install u-boot binaries in addition to u-boot scripts for the Pi
    - Copy overlay_map.dtb into overlays/ sub-directory instead of the
      root of the boot partition (LP: 1918110)
    - Add minor board revisions to db/all.db
    - Add support for FIT images
      + Support for ITS files
      + New Boot-FIT-Path and Boot-ITS-File-Name DB fields
    - Add Xilinx Kria SOM and ZCU10{2,4,6} boards to the devices database
    - Drop the "systemd.gpt_auto=0 rd.systemd.unit=basic.target" values from
      the snapd_standard_params, which have not been needed since pre-GA of
      UC20 and were removed in pc gadget on 20th April 2020. (LP: 1933093)
    - mkimage_fit: subst KERNEL_VERSION in ITS file with actual kernel
      version.
    - Add DB entry, bootscript and ITS templates for Mediatek AIoT i500 board.
    - Added note in db/all.db above Pi entries about "incorrect" DTB-Id
      (LP: 1928314)
    - Added entries for the Pi 4B rev 1.5, and moved CM4 and 400 models to their
      own entries for the sake of clarity
    - Include overlays/README in the files copied by Method: pi
    - Add Kria KR260 support
    - bootscr.zynqmp:
      + Add Kria KV260 support on jammy and kinetic
      + Add ZCU102/104/106 support on jammy and kinetic
    - image-kria.its: add dtb files into fitimage
    - Add kernel parameter for Kria TSN
    - Add ZCU111 support (LP: 1978798)
    - bootscr.zynqmp (LP: 1978798)
      + Improve messaging in U-Boot boot script for board detection
      + Add kria and zcu board support lists
      + Update kR260 and KV260's bootargs as per AMD-Xilinx's request
      + Support legacy KV260 U-Boot
    - Allow to bypass container exit test by introducing FK_FORCE_CONTAINER
      for RISC-V images build to run flash-kernel in a container (LP: 1980929)
    - Unconditionally map 'armmp' in the Kernel-Flavors field to 'generic',
      which is what this flavor is called in Ubuntu.  This allows us to support
      a much greater number of boards without having to carry an extensive
      delta against the all.db data file.
    - Add Mediatek AIoT i1200 board support
    - Fix Microchip Icicle Kit DTB name (LP: 1988169)
    - Change FK_FORCE_CONTAINER to FK_FORCE and cleanly exit if running
      in a chroot environment (LP: 1955353)
    - Fix remaining reference to FK_FORCE_CONTAINER (LP: 1955353)
    - Add database entry for Lenovo X13s (LP: 2002092)
    - Add support for the NXP S32G274A-RDB2 (LP: 2004495)
      + Add entry in db/all.db using the generic U-Boot method, the kernel
        provided s33g274a-rdb2 device tree to generate a FIT image under
        boot/firmware/fitImage.
      + Add its/arm64/image-nxp-s32.its FIT image template applicable for all
        S32x boards.
    - Add support for Xilinx Versal VCK190 (LP: 2006558)
    - Ensure that only kernels in fully "installed" state are considered for
      flashing (LP: 2007827)
    - test_functions: Add tests for include_only_flavors
    - Handle "not fully installed" kernels differently by quitting instead of
      re-triggering to avoid a dpkg trigger cycle (LP: 2011925)
    - d/control: Remove redundant awk dependency to appease lintian
    - Use "any" kernel flavor for all RISC-V boards
    - Add support for Sipeed Lichee Pi 4A
    - Use generic-revision catch-alls for each model rather than relying on a
      single Pi catch-all to avoid a confusing selection of "the one DTB" for a
      given board (even though all other DTBs will still be copied anyway)
      (LP: 2038087)
      + Add missing Pi Zero 2W entry
      + Add missing Pi 5B entry
    - Use LC_ALL= instead of LANG= for consistency (LP: 2007827)
    - Add support for Xilinx Kria KD240 (LP: 2037407)
      + Fix minor issues in bootscr.zynqmp
    - Add raspi-realtime kernel flavor to bcm2711 and bcm2712 based Pi boards
      (LP: 2051960)
    - Update Xilinx board support (LP: 2054556)
      + Remove support claim for Xilinx ZCU111
      + Add new machine entries for KV260 and KR260 due to model string changes
      + Create separate bootscript for AMD-Xilinx Kria board family
    - db/all.db: Fix Raspberry Pi 2 entry for noble. Here we can assume it is
      definitely the 64-bit revision (1.2) board, but this change must not
      be backported earlier than noble where this assumption does not hold
      (LP: 2060856)
    - db/all.db: Add Microchip PIC64GX Curiosity Kit (LP: 2072500)
    - db/all.db: Support for Qualcomm x1e80100 CRD board (LP: 2065380)
    - db/all.db: add CM5 entry (LP: 2086774)
    - db/all.db: add HiFive Premier P550 to database (LP: 2077981)
    - Add support for AMD-Xilinx Kria noble kernel (LP: 2069802)
      + bootscript/arm64/bootscr.zynqmp.kria: Update cma value
        - CMA value of 1G at start address of 0 is not working with Ubuntu noble
          optimized kernel on ZynqMP Kria K26 platforms
      + db/all.db: change kernel-flavor for Kria platforms in noble because of
        the kernel name change
      + its/arm64/image-kria.its: use new device-tree file names
    - Add Samsung Galaxy Book4 Edge
    - db/all.db: Add entry for Raspberry Pi 500 (LP: 2092216)
    - test_functions: Remove test for android_skip_initrd (obsolete with
      removal of Nexus 4 (Mako) delta)
    - db/all.db: Add another RISC-V board (LP: 2093200)
      + Add entry for DeepComputing FML13V01
  * Removed patches obsoleted/merged by upstream:
    - Add Asus Vivobook S 15
    - Add Dell XPS 13 9345
    - Add HP Omnibook X 14
    - Add Lenovo Thinkpad T14s Gen6
    - Add Lenovo Yoga Slim 7x
    - Add Microsoft Surface Laptop 7 variants
    - Add entry for Pine64 Star64
  * db/all.db: Fix entries with "Kernel-Flavors: arm64". (LP: #2092737)
  * db/all.db: Add CM5 Lite to flash-kernel database (LP: #2097008)

 -- Pragyansh Chaturvedi <pragyansh.chaturvedi@canonical.com>  Fri, 02 May 2025 17:43:46 +0530

flash-kernel (3.109) unstable; urgency=medium

  [ Heinrich Schuchardt ]
  * flash-kernel.8: describe /etc/default/flash-kernel

  [ D-I role ]
  * [l10n]  Commit changed/added po files (from l10n-sync run at dillon)

  [ Vagrant Cascadian ]
  * Add Pine64 Pinebook.

  [ Johannes Schauer Marin Rodrigues ]
  * add support for MNT Reform 2 with RCORE RK3588 Module

  [ Josua Mayer ]
  * Add machine db entries for solidrun am64 based hummingboard-t

  [ Alex Lowe ]
  * db: add Pine64 Star64 (Closes: #1092359)

  [ Heinrich Schuchardt ]
  * db: add entry for Wandboard rev D1 board

  [ Tobias Heider ]
  * Add X Elite devices:
    HP Omnibook X 14
    Lenovo Yoga Slim 7x
    Asus Vivobook S 15
    Dell XPS 13 9345
    Lenovo Thinkpad T14s Gen6
    Microsoft Surface Laptop 7 variants

  [ Vagrant Cascadian ]
  * flash-kernel.8: Fix spelling of "command".
  * debian/control: Update Standards-Version to 4.7.2.

 -- Vagrant Cascadian <vagrant@debian.org>  Tue, 08 Apr 2025 15:56:42 -0700

flash-kernel (3.108ubuntu2) plucky; urgency=medium

  * Prevent removal of flash-kernel on switch to dracut (LP: #2100618)

 -- Dave Jones <dave.jones@canonical.com>  Fri, 21 Mar 2025 13:41:50 +0000

flash-kernel (3.108ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable (LP: #2081313). Remaining changes:
    - Add support for Raspberry Pi 2, 3, 3+, CM3, CM3+, and 4 using a unified
      bootscript (replaces upstream's entries)
      - Update pi bootscript to support all flash-kernel vars, including
        calculated devtype and partition for future USB boot support
      - Add entry for Raspberry Pi 3A+
      - Add entry for Raspberry Pi CM4
      - Add entry for Raspberry Pi 400
      - Import UC20 updates to the rpi bootscript from the snappy-dev/image
        PPA
    - Add Kernel-Flavors check to Raspberry Pi entries
      - Support "raspi" kernel flavor
    - use umount -l in the cleanup function, else we fail while finishing up
      with the script
    - add a diversion for update-initramfs to live-installers post-base-
      installer.d to avoid update-initramfs runs before flash-kernel is
      configured
    - add a check for the diverted update-initramfs to flash-kernel-installer,
      so it gets reverted before we try to call update-initramfs
    - make post-base-installer.d/01flash-kernel-diversion actually an
      executable shell script
    - make sure that /dev is bind mounted in /target when running update-
      initramfs from flash-kernel-installer, else we do not find the boot
      media (this is only a workaround, actual fixing of the netinst
      environment is needed to fix this properly)
    - drop the "|| true" from the initramfs building code, if we fail here we
      actually dont want to attempt to flash that
    - Do not run flash-kernel inside an LXC container
    - Migrate default /etc/default/flash-kernel content to new default without
      asking via debconf
    - Filter the selection of 'latest' usable kernel through the whitelist.
    - Do not fail if there are no specified Kernel-Flavors for this machine.
    - flash-kernel/functions: Stop attempting to install the latest kernel if
      we request an older version, just refuse to act without --force.
    - Look for dtbs in /lib/firmware/$kvers/device-tree/ in find_dtb_file()
    - Allow us to find DTBs in both the old flat layout and the new vendor
      subdirectory layout, so we keep backward compatibility
    - Add support for gzip-compressed kernel images
    - Fix mkimage_kernel tests
    - Add tests for android-related functions
    - Add "pi" value for the "Method" field which copies all dtbs and overlays
      to the boot partition and provides defaults for the boot paths of the
      kernel, initrd, and u-boot script.
      - This fixes upgrades to support the Pi 4 on Bionic
      - Permit initrd to be missing in flash-kernel
      - Make U-boot optional in the "pi" method. From Groovy onwards, U-Boot
        will be an option in the boot chain but not activated by default. For
        the time being, the U-Boot-Script-Name will remain in the Pi entries,
        but this commit permits it to be blank in future.
      - Copy the Pi's bootloader firmware. At present, the Pi's bootloader
        firmware is being copied to the boot partition by the postinst of the
        linux-firmware-raspi2 package. However, flash-kernel should be
        responsible for copying *everything* necessary to boot the Linux
        kernel, hence this responsibility should be transferred to flash-
        kernel.
    - Ensure tests work independently of sort implementation
    - Always run flash-kernel on install/upgrade
    - Add pattern matching for machines
      - A requirement has come up to permit a simple form of pattern matching
        (specifically shell-style globbing) in the Machine field of the
        database. This commit implements this via a "case" match.
    - Install u-boot binaries in addition to u-boot scripts for the Pi
    - Copy overlay_map.dtb into overlays/ sub-directory instead of the root of
      the boot partition
    - Add minor board revisions to db/all.db
    - Add support for FIT images
      - Support for ITS files
      - New Boot-FIT-Path and Boot-ITS-File-Name DB fields
    - Add Xilinx Kria SOM and ZCU10{2,4,6} boards to the devices database
    - Drop the "systemd.gpt_auto=0 rd.systemd.unit=basic.target" values from
      the snapd_standard_params, which have not been needed since pre-GA of
      UC20 and were removed in pc gadget on 20th April 2020.
    - mkimage_fit: subst KERNEL_VERSION in ITS file with actual kernel
      version.
    - Add DB entry, bootscript and ITS templates for Mediatek AIoT i500 board.
    - Added note in db/all.db above Pi entries about "incorrect" DTB-Id
    - Added entries for the Pi 4B rev 1.5, and moved CM4 and 400 models to
      their own entries for the sake of clarity
    - Include overlays/README in the files copied by Method: pi
    - Add Kria KR260 support
    - bootscr.zynqmp:
      - Add Kria KV260 support on jammy and kinetic
      - Add ZCU102/104/106 support on jammy and kinetic
    - image-kria.its: add dtb files into fitimage
    - Add kernel parameter for Kria TSN
    - Add ZCU111 support
    - bootscr.zynqmp
      - Improve messaging in U-Boot boot script for board detection
      - Add kria and zcu board support lists
      - Update kR260 and KV260's bootargs as per AMD-Xilinx's request
      - Support legacy KV260 U-Boot
    - Allow to bypass container exit test by introducing FK_FORCE_CONTAINER
      for RISC-V images build to run flash-kernel in a container
    - Unconditionally map 'armmp' in the Kernel-Flavors field to 'generic',
      which is what this flavor is called in Ubuntu.  This allows us to
      support a much greater number of boards without having to carry an
      extensive delta against the all.db data file.
    - Add Mediatek AIoT i1200 board support
    - Fix Microchip Icicle Kit DTB name
    - Change FK_FORCE_CONTAINER to FK_FORCE and cleanly exit if running in a
      chroot environment
    - Fix remaining reference to FK_FORCE_CONTAINER
    - Add database entry for Lenovo X13s
    - Add support for the NXP S32G274A-RDB2
      - Add entry in db/all.db using the generic U-Boot method, the kernel
        provided s33g274a-rdb2 device tree to generate a FIT image under
        boot/firmware/fitImage.
      - Add its/arm64/image-nxp-s32.its FIT image template applicable for all
        S32x boards.
    - Add support for Xilinx Versal VCK190
    - Ensure that only kernels in fully "installed" state are considered for
      flashing
    - test_functions: Add tests for include_only_flavors
    - Handle "not fully installed" kernels differently by quitting instead of
      re-triggering to avoid a dpkg trigger cycle
    - d/control: Remove redundant awk dependency to appease lintian
    - Use "any" kernel flavor for all RISC-V boards
    - Add support for Sipeed Lichee Pi 4A
    - Use generic-revision catch-alls for each model rather than relying on a
      single Pi catch-all to avoid a confusing selection of "the one DTB" for
      a given board (even though all other DTBs will still be copied anyway)
      - Add missing Pi Zero 2W entry
      - Add missing Pi 5B entry
    - Use LC_ALL= instead of LANG= for consistency
    - Add support for Xilinx Kria KD240
      - Fix minor issues in bootscr.zynqmp
    - Add raspi-realtime kernel flavor to bcm2711 and bcm2712 based Pi boards
    - Update Xilinx board support
      - Remove support claim for Xilinx ZCU111
      - Add new machine entries for KV260 and KR260 due to model string
        changes
      - Create separate bootscript for AMD-Xilinx Kria board family
    - db/all.db: Fix Raspberry Pi 2 entry for noble. Here we can assume it is
      definitely the 64-bit revision (1.2) board, but this change must not be
      backported earlier than noble where this assumption does not hold
    - db/all.db: Add Microchip PIC64GX Curiosity Kit
    - db/all.db: Support for Qualcomm x1e80100 CRD board
    - db/all.db: add CM5 entry
    - db/all.db: add HiFive Premier P550 to database
    - Add support for AMD-Xilinx Kria noble kernel
      - bootscript/arm64/bootscr.zynqmp.kria: Update cma value
        - CMA value of 1G at start address of 0 is not working with Ubuntu
          noble optimized kernel on ZynqMP Kria K26 platforms
      - db/all.db: change kernel-flavor for Kria platforms in noble because of
        the kernel name change
      - its/arm64/image-kria.its: use new device-tree file names
    - Add Asus Vivobook S 15
    - Add Dell XPS 13 9345
    - Add HP Omnibook X 14
    - Add Lenovo Thinkpad T14s Gen6
    - Add Lenovo Yoga Slim 7x
    - Add Microsoft Surface Laptop 7 variants
    - Add Samsung Galaxy Book4 Edge
  * Removed obsolete patches/changes:
    - Add support for QCT APQ8064 CDP
      - Add support for QCT APQ8064 CDP; thanks Alfonso Sanchez-Beato.
    - Add support for Calxeda Highbank
      - Add support for Calxeda Highbank (with bootscr.highbank different from
        Debian's version)
      - bootscr.highbank: allow more space to load larger kernels
    - Add support for Nexus 4 (Mako)
      - Enabling support for mako (Nexus 4)
    - Add support for Marvell ArmadaXP
      - Re-add support for Marvell ArmadaXP
      - Fix armadaxp kernel load address
    - Add support for Samsung Exynos 5440 platforms
      - Add support for EXYNOS5440-based platforms
    - Add generic-lpae to the XB-Subarchitecture list in debian/control
    - debian/flash-kernel-installer.isinstallable: add arm*/generic-lpae
    - Add support for HP ProLiant m400 cartridges
      - Add support for HP ProLiant m400 Server Cartridges
      - HP Moonshot Cartridges: Use $baudrate from u-boot environment as
        serial console speed
      - HP Moonshot Cartridges: Enable hardware flow control as required by
        the HP moonshot chassis
      - Enable U-Boot environment support for X-Gene platforms
      - Use filesystem agnostic "load" command instead of assuming ext4
      - Add a bootscript specific to X-Gene Mustang boards since they need to
        pull their dtb from the OS.
    - Add support for OMAP3 and OMAP4 boards
      - add DB entry for "OMAP3 Beagle Board" (funnily thats missing)
      - add Panda to the list of supported board in the README file
      - debian/control: Re-add omap and omap4 to the flash-kernel-installer
        XB-Subarchitecture field. These appear to have been lost somewhere
        along the way.
      - Also add omap and omap4 to flash-kernel-installer.isinstallable.
      - switch omap3 and omap4 to uEnv.txt/preEnv.txt (the former holds all
        active boot commands, the latter holds the kernel commandline only)
      - switch omap3 and omap4 from Bootloader-sets-root: no to yes, we now
        generate a root=UUID= line on the fly for arches using
        uEnv.txt/preEnv.txt
      - introduce bootscript/uEnvtxt.omap
      - do not move the original uEnvtxt.omap to the target, use a copy
        instead
      - add "quiet splash" as default options to omap bootscr
    - enable UUID detection of the currently used root device
    - if uEnv.txt is defined in the db for an arch, generate preEnv.txt from
      UBOOT_DEFAULTS and UUID detection data
    - make sure blkid only gives us the UUID and not any other metadata like
      labels or filesystem
    - hide the boot device from udisk's automounting after installation on all
      systems using uEnv.txt to configure u-boot
    - make sure we only rename the bootrom partition so udisks hides it, when
      using mkdosfs for setting the label like we did in jasper (where we
      cached the contents before doing this) MLO and u-boot.bin are gone
    - Add support for grouper boards
      - add support for the grouper architecture
    - Add support for Wandboard Quad
      - Wandboard: Use /dev/disk/by-path/platform-2198000.usdhc-part1 instead
        of the hardcoded mmcblk1p1, this should make things work on boards
        with just a single microSD card in.
      - Add basic support for WandBoard Quad.
    - Add support for AAarch64 Qualcomm laptops.
      - Fix AARCH64 qcom laptop names, to those accepted upstream and in the
        Ubuntu kernel.
    - Install all potential uboot scripts [previously undocumented]
    - make sure that if we dont want to override the bootloader root= option
      by setting "Bootloader-sets-root: yes", we actually dont do it
    - Update tests with new fields: Bootloader-sets-root
    - Add workaround for older u-boot versions that can fail to read files
      using ext4 extents, and enable it for HP ProLiant m400 Moonshot Server
      Cartridges.
    - Make errors in workaround for HP Proliant m400 u-boot ext4 parsing bug
      fatal.
    - Introduce "Boot-Kernel-Max-Size" and support for compressing kernel
      images that exceed it. This will allow installation of larger
      uncompressed kernels on HP ProLiant m400 cartridges.
    - Cache lookup of Bootloader-Has-Broken-Ext4-Extent-Support for
      significant performance improvement on Raspberry Pi
    - Add raspi-nolpae kernel flavor to all supported boards
    - Remove raspi-nolpae kernel flavor from all Pi boards
    - Add dtb-probe script to handle missing bcm2710-rpi-zero-2-w.dtb in some
      of the 5.15 series kernels
  * Removed patches obsoleted/merged by upstream:
    - Add support for the LicheeRV Dock
    - Add StarFive VisionFive 2 board to db/all.db
    - Add Milk-V Mars to database
    - Bump standards version
  * db/all.db: Add entry for Raspberry Pi 500 (LP: #2092216)
  * db/all.db: Add more RISC-V boards (LP: #2093200)
    - Add entry for DeepComputing FML13V01
    - Add entry for Pine64 Star64
  * test_functions: Remove test for android_skip_initrd (obsolete with
    removal of Nexus 4 (Mako) delta)

 -- Dave Jones <dave.jones@canonical.com>  Thu, 05 Dec 2024 12:10:28 +0000

flash-kernel (3.108) unstable; urgency=medium

  [ Manfred Stock ]
  * Add Radxa ROCK 4C+

  [ Alban Browaeys ]
  * db: remove armmp-lpae from Odroid U3 definition

  [ James Addison ]
  * Add support for Raspberry Pi 400 Rev 1.0

  [ Sascha Silbe ]
  * Add support for BeagleBoard.org BeagleBone AI-64 (Closes: #1036457)

  [ Manuel Traut ]
  * Add machine db entry for Colibri iMX6 Evalboard

  [ JiaLing Zhang ]
  * Add loong64 to supported binary architectures
    (Closes: #1050156, #1059960)

  [ Juerg Haefliger ]
  * Don't run if machine is 'none'

  [ Francesco Dolcini ]
  * Add machine db entries for Colibri iMX7 eMMC

  [ Heinrich Schuchardt ]
  * db: add Sipeed Lichee Pi 4A (Closes: #1060292)
  * db: add StarFive VisionFive 2 v1.2A and v1.3B
  * db: add Sipeed Lichee RV Dock
  * functions: support kernel named vmlinux-* (Closes: #1069869)
  * all.db: add Milk-V Mars

  [ Josua Mayer ]
  * Add machine db entry for lx2162 clearfog (Closes: #1076085)
  * Add machine db entries for solidrun cn9130 based platforms
    (Closes: #1076085)

  [ David Gibson ]
  * Include essential btrfs mount options for root mount

  [ Vagrant Cascadian ]
  * db/all.db: Fix sort order.
  * debian/control: Update to Standards-Version 4.7.0.

 -- Vagrant Cascadian <vagrant@debian.org>  Wed, 17 Jul 2024 13:19:31 -0700

flash-kernel (3.107ubuntu14) plucky; urgency=medium

  * Add Asus Vivobook S 15
  * Add Dell XPS 13 9345
  * Add HP Omnibook X 14
  * Add Lenovo Thinkpad T14s Gen6
  * Add Lenovo Yoga Slim 7x
  * Add Microsoft Surface Laptop 7 variants
  * Add Samsung Galaxy Book4 Edge

 -- Tobias Heider <tobias.heider@canonical.com>  Sat, 16 Nov 2024 23:20:01 +0100

flash-kernel (3.107ubuntu13) plucky; urgency=medium

  [ Talha Can Havadar ]
  * Add support for AMD-Xilinx Kria noble kernel (LP: #2069802)
    - bootscript/arm64/bootscr.zynqmp.kria: Update cma value
      - CMA value of 1G at start address of 0 is not working with Ubuntu noble
        optimized kernel on ZynqMP Kria K26 platforms
    - db/all.db: change kernel-flavor for Kria platforms in noble because of
      the kernel name change
    - its/arm64/image-kria.its: use new device-tree file names

  [ Heinrich Schuchardt ]
  * db/all.db: add HiFive Premier P550 to database (LP: #2077981)

  [ Dave Jones ]
  * db/all.db: add CM5 entry (LP: #2086774)

 -- Dave Jones <dave.jones@canonical.com>  Wed, 06 Nov 2024 13:39:21 +0000

flash-kernel (3.107ubuntu11) oracular; urgency=medium

  * Add dtb-probe script to handle missing bcm2710-rpi-zero-2-w.dtb in some of
    the 5.15 series kernels (LP: #2078525)

 -- Dave Jones <dave.jones@canonical.com>  Tue, 10 Sep 2024 16:32:47 +0100

flash-kernel (3.107ubuntu10) oracular; urgency=medium

  * db/all.db: Support for Qualcomm x1e80100 CRD board (LP: #2065380)

 -- Ike Panhc <ike.pan@canonical.com>  Mon, 22 Jul 2024 16:39:56 +0800

flash-kernel (3.107ubuntu9) oracular; urgency=medium

  * db/all.db: Add Microchip PIC64GX Curiosity Kit (LP: #2072500)

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Mon, 08 Jul 2024 16:00:03 +0200

flash-kernel (3.107ubuntu8) noble; urgency=medium

  * db/all.db: Fix Raspberry Pi 2 entry for noble. Here we can assume it is
    definitely the 64-bit revision (1.2) board, but this change must not
    be backported earlier than noble where this assumption does not hold
    (LP: #2060856)

 -- Dave Jones <dave.jones@canonical.com>  Wed, 10 Apr 2024 22:40:05 +0100

flash-kernel (3.107ubuntu7) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 17:57:37 +0200

flash-kernel (3.107ubuntu6) noble; urgency=medium

  * Add Milk-V Mars to database (LP: #2053028)

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Fri, 23 Feb 2024 16:10:56 +0100

flash-kernel (3.107ubuntu5) noble; urgency=medium

  [ Juerg Haefliger ]
  * Remove raspi-nolpae kernel flavor from all Pi boards (LP: #2048864)
  * Add raspi-realtime kernel flavor to bcm2711 and bcm2712 based Pi boards
    (LP: #2051960)

  [ Talha Can Havadar ]
  * Update Xilinx board support (LP: #2054556)
    - Remove support claim for Xilinx ZCU111
    - Add new machine entries for KV260 and KR260 due to model string changes
    - Create separate bootscript for AMD-Xilinx Kria board family

 -- Dave Jones <dave.jones@canonical.com>  Thu, 22 Feb 2024 15:29:21 +0000

flash-kernel (3.107ubuntu4) noble; urgency=medium

  * Add support for Xilinx Kria KD240 (LP: #2037407)
    - Fix minor issues in bootscr.zynqmp

 -- Talha Can Havadar <talha.can.havadar@canonical.com>  Fri, 08 Dec 2023 14:17:40 +0000

flash-kernel (3.107ubuntu3) noble; urgency=medium

  * Use LC_ALL= instead of LANG= for consistency (LP: #2007827)

 -- Dave Jones <dave.jones@canonical.com>  Fri, 10 Nov 2023 09:39:34 +0200

flash-kernel (3.107ubuntu2) mantic; urgency=medium

  * Use generic-revision catch-alls for each model rather than relying on a
    single Pi catch-all to avoid a confusing selection of "the one DTB" for a
    given board (even though all other DTBs will still be copied anyway)
    (LP: #2038087)
    - Add missing Pi Zero 2W entry
    - Add missing Pi 5B entry

 -- Dave Jones <dave.jones@canonical.com>  Mon, 02 Oct 2023 12:59:44 +0100

flash-kernel (3.107ubuntu1) mantic; urgency=medium

  [ Dave Jones ]
  * Merge from Debian unstable (LP: #2024672). Remaining changes:
    - Add support for QCT APQ8064 CDP
      - Add support for QCT APQ8064 CDP; thanks Alfonso Sanchez-Beato.
    - Add support for Calxeda Highbank
      - Add support for Calxeda Highbank (with bootscr.highbank different from
        Debian's version)
      - bootscr.highbank: allow more space to load larger kernels
    - Add support for Nexus 4 (Mako)
      - Enabling support for mako (Nexus 4)
    - Add support for Marvell ArmadaXP
      - Re-add support for Marvell ArmadaXP
      - Fix armadaxp kernel load address
    - Add support for Samsung Exynos 5440 platforms
      - Add support for EXYNOS5440-based platforms
    - Add generic-lpae to the XB-Subarchitecture list in debian/control
    - debian/flash-kernel-installer.isinstallable: add arm*/generic-lpae
    - Add support for HP ProLiant m400 cartridges
      - Add support for HP ProLiant m400 Server Cartridges
      - HP Moonshot Cartridges: Use $baudrate from u-boot environment as
        serial console speed
      - HP Moonshot Cartridges: Enable hardware flow control as required by
        the HP moonshot chassis
      - Enable U-Boot environment support for X-Gene platforms
      - Use filesystem agnostic "load" command instead of assuming ext4
      - Add a bootscript specific to X-Gene Mustang boards since they need to
        pull their dtb from the OS.
    - Add support for OMAP3 and OMAP4 boards
      - add DB entry for "OMAP3 Beagle Board" (funnily thats missing)
      - add Panda to the list of supported board in the README file
      - debian/control: Re-add omap and omap4 to the flash-kernel-installer
        XB-Subarchitecture field. These appear to have been lost somewhere
        along the way.
      - Also add omap and omap4 to flash-kernel-installer.isinstallable.
      - switch omap3 and omap4 to uEnv.txt/preEnv.txt (the former holds all
        active boot commands, the latter holds the kernel commandline only)
      - switch omap3 and omap4 from Bootloader-sets-root: no to yes, we now
        generate a root=UUID= line on the fly for arches using
        uEnv.txt/preEnv.txt
      - introduce bootscript/uEnvtxt.omap
      - do not move the original uEnvtxt.omap to the target, use a copy
        instead
      - add "quiet splash" as default options to omap bootscr
    - enable UUID detection of the currently used root device
    - if uEnv.txt is defined in the db for an arch, generate preEnv.txt from
      UBOOT_DEFAULTS and UUID detection data
    - make sure blkid only gives us the UUID and not any other metadata like
      labels or filesystem
    - hide the boot device from udisk's automounting after installation on all
      systems using uEnv.txt to configure u-boot
    - make sure we only rename the bootrom partition so udisks hides it, when
      using mkdosfs for setting the label like we did in jasper (where we
      cached the contents before doing this) MLO and u-boot.bin are gone
    - Add support for grouper boards
      - add support for the grouper architecture
    - Add support for Wandboard Quad
      - Wandboard: Use /dev/disk/by-path/platform-2198000.usdhc-part1 instead
        of the hardcoded mmcblk1p1, this should make things work on boards
        with just a single microSD card in.
      - Add basic support for WandBoard Quad.
    - Add support for AAarch64 Qualcomm laptops.
      - Fix AARCH64 qcom laptop names, to those accepted upstream and in the
        Ubuntu kernel.
    - Add support for Raspberry Pi 2, 3, 3+, CM3, CM3+, and 4 using a unified
      bootscript (replaces upstream's entries)
      - Update pi bootscript to support all flash-kernel vars, including
        calculated devtype and partition for future USB boot support
      - Install all potential uboot scripts [previously undocumented]
      - Add entry for Raspberry Pi 3A+
      - Add entry for Raspberry Pi CM4
      - Add entry for Raspberry Pi 400
      - Import UC20 updates to the rpi bootscript from the snappy-dev/image
        PPA
    - Add Kernel-Flavors check to Raspberry Pi entries
      - Support "raspi" kernel flavor
    - make sure that if we dont want to override the bootloader root= option
      by setting "Bootloader-sets-root: yes", we actually dont do it
    - Update tests with new fields: Bootloader-sets-root
    - use umount -l in the cleanup function, else we fail while finishing up
      with the script
    - add a diversion for update-initramfs to live-installers post-base-
      installer.d to avoid update-initramfs runs before flash-kernel is
      configured
    - add a check for the diverted update-initramfs to flash-kernel-installer,
      so it gets reverted before we try to call update-initramfs
    - make post-base-installer.d/01flash-kernel-diversion actually an
      executable shell script
    - make sure that /dev is bind mounted in /target when running update-
      initramfs from flash-kernel-installer, else we do not find the boot
      media (this is only a workaround, actual fixing of the netinst
      environment is needed to fix this properly)
    - drop the "|| true" from the initramfs building code, if we fail here we
      actually dont want to attempt to flash that
    - Do not run flash-kernel inside an LXC container
    - Migrate default /etc/default/flash-kernel content to new default without
      asking via debconf
    - Filter the selection of 'latest' usable kernel through the whitelist.
    - Do not fail if there are no specified Kernel-Flavors for this machine.
    - flash-kernel/functions: Stop attempting to install the latest kernel if
      we request an older version, just refuse to act without --force.
    - Look for dtbs in /lib/firmware/$kvers/device-tree/ in find_dtb_file()
    - Allow us to find DTBs in both the old flat layout and the new vendor
      subdirectory layout, so we keep backward compatibility
    - Add support for gzip-compressed kernel images
    - Fix mkimage_kernel tests
    - Add tests for android-related functions
    - Add "pi" value for the "Method" field which copies all dtbs and overlays
      to the boot partition and provides defaults for the boot paths of the
      kernel, initrd, and u-boot script.
      - This fixes upgrades to support the Pi 4 on Bionic
      - Permit initrd to be missing in flash-kernel
      - Make U-boot optional in the "pi" method. From Groovy onwards, U-Boot
        will be an option in the boot chain but not activated by default. For
        the time being, the U-Boot-Script-Name will remain in the Pi entries,
        but this commit permits it to be blank in future.
      - Copy the Pi's bootloader firmware. At present, the Pi's bootloader
        firmware is being copied to the boot partition by the postinst of the
        linux-firmware-raspi2 package. However, flash-kernel should be
        responsible for copying *everything* necessary to boot the Linux
        kernel, hence this responsibility should be transferred to flash-
        kernel.
    - Ensure tests work independently of sort implementation
    - Always run flash-kernel on install/upgrade
    - Add pattern matching for machines
      - A requirement has come up to permit a simple form of pattern matching
        (specifically shell-style globbing) in the Machine field of the
        database. This commit implements this via a "case" match.
    - Add workaround for older u-boot versions that can fail to read files
      using ext4 extents, and enable it for HP ProLiant m400 Moonshot Server
      Cartridges.
    - Make errors in workaround for HP Proliant m400 u-boot ext4 parsing bug
      fatal.
    - Install u-boot binaries in addition to u-boot scripts for the Pi
    - Copy overlay_map.dtb into overlays/ sub-directory instead of the root of
      the boot partition
    - Add minor board revisions to db/all.db
    - Add support for FIT images
      - Support for ITS files
      - New Boot-FIT-Path and Boot-ITS-File-Name DB fields
    - Add Xilinx Kria SOM and ZCU10{2,4,6} boards to the devices database
    - Drop the "systemd.gpt_auto=0 rd.systemd.unit=basic.target" values from
      the snapd_standard_params, which have not been needed since pre-GA of
      UC20 and were removed in pc gadget on 20th April 2020.
    - Introduce "Boot-Kernel-Max-Size" and support for compressing kernel
      images that exceed it. This will allow installation of larger
      uncompressed kernels on HP ProLiant m400 cartridges.
    - mkimage_fit: subst KERNEL_VERSION in ITS file with actual kernel
      version.
    - Add DB entry, bootscript and ITS templates for Mediatek AIoT i500 board.
    - Cache lookup of Bootloader-Has-Broken-Ext4-Extent-Support for
      significant performance improvement on Raspberry Pi
    - Added note in db/all.db above Pi entries about "incorrect" DTB-Id
    - Add raspi-nolpae kernel flavor to all supported boards
    - Added entries for the Pi 4B rev 1.5, and moved CM4 and 400 models to
      their own entries for the sake of clarity
    - Include overlays/README in the files copied by Method: pi
    - Add Kria KR260 support
    - bootscr.zynqmp:
      - Add Kria KV260 support on jammy and kinetic
      - Add ZCU102/104/106 support on jammy and kinetic
    - image-kria.its: add dtb files into fitimage
    - Add kernel parameter for Kria TSN
    - Add ZCU111 support
    - bootscr.zynqmp
      - Improve messaging in U-Boot boot script for board detection
      - Add kria and zcu board support lists
      - Update kR260 and KV260's bootargs as per AMD-Xilinx's request
      - Support legacy KV260 U-Boot
    - Allow to bypass container exit test by introducing FK_FORCE_CONTAINER
      for RISC-V images build to run flash-kernel in a container
    - Unconditionally map 'armmp' in the Kernel-Flavors field to 'generic',
      which is what this flavor is called in Ubuntu.  This allows us to
      support a much greater number of boards without having to carry an
      extensive delta against the all.db data file.
    - Add Mediatek AIoT i1200 board support
    - Add support for the LicheeRV Dock
    - Fix Microchip Icicle Kit DTB name
    - Change FK_FORCE_CONTAINER to FK_FORCE and cleanly exit if running in a
      chroot environment
    - Fix remaining reference to FK_FORCE_CONTAINER
    - Add database entry for Lenovo X13s
    - Add support for the NXP S32G274A-RDB2
      - Add entry in db/all.db using the generic U-Boot method, the kernel
        provided s33g274a-rdb2 device tree to generate a FIT image under
        boot/firmware/fitImage.
      - Add its/arm64/image-nxp-s32.its FIT image template applicable for all
        S32x boards.
    - Add support for Xilinx Versal VCK190
    - Add StarFive VisionFive 2 board to db/all.db
    - Ensure that only kernels in fully "installed" state are considered for
      flashing
    - test_functions: Add tests for include_only_flavors
    - Handle "not fully installed" kernels differently by quitting instead of
      re-triggering to avoid a dpkg trigger cycle
    - Bump standards version
    - d/control: Remove redundant awk dependency to appease lintian
  * Removed patches obsoleted/merged by upstream:
    - db/all.db: add dummy entries as noops when running on VMs
    - Add StarFive VisionFive board to the database
    - Add support for VisionFive, Nezha and LicheeRV boards
    - db/all.db: add dummy entry for RISC-V under QEMU

  [ Heinrich Schuchardt ]
  * Use "any" kernel flavor for all RISC-V boards
  * Add support for Sipeed Lichee Pi 4A

 -- Dave Jones <dave.jones@canonical.com>  Thu, 22 Jun 2023 15:18:53 +0100

flash-kernel (3.107) unstable; urgency=medium

  [ Lubomir Rintel ]
  * Make the OLPC XO-1.75 boot script a bit more forgiving

  [ Heinrich Schuchardt ]
  * db: add Lenovo Miix 630 and Lenovo Yoga C630

  [ Alexandre Ghiti ]
  * Add the StarFive VisionFive board to the database.
  * Add D1 SoC boards to the database

  [ Johannes Schauer Marin Rodrigues ]
  * Choose a stable temporary file path for ucf

  [ Dave Jones ]
  * Add QEMU-related "dummy" entries

  [ Daniel Serpell ]
  * Add A20-OLinuXino_MICRO-eMMC. (Closes: #1019881)

  [ Heinrich Schuchardt ]
  * db: add Lenovo ThinkPad X13s

  [ Francesco Dolcini ]
  * Add machine db entries for Colibri iMX6ULL eMMC

  [ Heinrich Schuchardt ]
  * db: add 'Raspberry Pi 3 Model B Plus Rev 1.3'

  [ Isaac True ]
  * Skip EFI detection mechanism when the FK_IGNORE_EFI environment
    variable is set to "yes". (Closes: #1033737)

  [ Vagrant Cascadian ]
  * Set the value of FK_IGNORE_EFI from
    /etc/flash-kernel/ignore-efi. (Closes: #1033737)

 -- Vagrant Cascadian <vagrant@debian.org>  Wed, 19 Apr 2023 14:12:53 -0700

flash-kernel (3.106ubuntu14) lunar; urgency=medium

  * Handle "not fully installed" kernels differently by quitting instead of
    re-triggering to avoid a dpkg trigger cycle (LP: #2011925)

 -- Dave Jones <dave.jones@canonical.com>  Thu, 23 Mar 2023 14:12:19 +0000

flash-kernel (3.106ubuntu13) lunar; urgency=medium

  * Ensure that only kernels in fully "installed" state are considered for
    flashing (LP: #2007827)
  * test_functions: Add tests for include_only_flavors
  * d/control: Remove redundant awk dependency to appease lintian
  * Bump standards version

 -- Dave Jones <dave.jones@canonical.com>  Mon, 27 Feb 2023 11:53:49 +0000

flash-kernel (3.106ubuntu12) lunar; urgency=medium

  * Add StarFive VisionFive 2 board to db/all.db (LP: #2007981)

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Tue, 21 Feb 2023 14:52:26 +0100

flash-kernel (3.106ubuntu11) lunar; urgency=medium

  * Add support for Xilinx Versal VCK190 (LP: #2006558)

 -- Ethan Hsieh <ethan.hsieh@canonical.com>  Wed, 08 Feb 2023 15:49:46 +0800

flash-kernel (3.106ubuntu10) lunar; urgency=medium

  * Add support for the NXP S32G274A-RDB2 (LP: #2004495)
    - Add entry in db/all.db using the generic U-Boot method, the kernel
      provided s33g274a-rdb2 device tree to generate a FIT image under
      boot/firmware/fitImage.
    - Add its/arm64/image-nxp-s32.its FIT image template applicable for all
      S32x boards.

 -- Isaac True <isaac.true@canonical.com>  Wed, 01 Feb 2023 15:30:35 +0000

flash-kernel (3.106ubuntu9) lunar; urgency=medium

  * Add database entry for Lenovo X13s (LP: #2002092)

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Fri, 06 Jan 2023 13:27:16 +0100

flash-kernel (3.106ubuntu8) kinetic; urgency=medium

  * Fix remaining reference to FK_FORCE_CONTAINER (LP: #1955353)

 -- Dave Jones <dave.jones@canonical.com>  Mon, 17 Oct 2022 13:46:14 +0100

flash-kernel (3.106ubuntu7) kinetic; urgency=medium

  * Change FK_FORCE_CONTAINER to FK_FORCE and cleanly exit if running
    in a chroot environment (LP: #1955353)

 -- William 'jawn-smith' Wilson <jawn-smith@ubuntu.com>  Thu, 08 Sep 2022 09:16:55 -0500

flash-kernel (3.106ubuntu6) kinetic; urgency=medium

  * Add support for the LicheeRV Dock (LP: #1987735)
  * Fix Microchip Icicle Kit DTB name (LP: #1988169)

 -- Alexandre Ghiti <alexandre.ghiti@canonical.com>  Tue, 30 Aug 2022 15:07:30 +0200

flash-kernel (3.106ubuntu5) kinetic; urgency=medium

  * Add Mediatek AIoT i1200 board support

 -- Ethan Hsieh <ethan.hsieh@canonical.com>  Mon, 15 Aug 2022 10:51:16 +0800

flash-kernel (3.106ubuntu4) kinetic; urgency=medium

  * Unconditionally map 'armmp' in the Kernel-Flavors field to 'generic',
    which is what this flavor is called in Ubuntu.  This allows us to support
    a much greater number of boards without having to carry an extensive
    delta against the all.db data file.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 01 Aug 2022 15:13:38 +0000

flash-kernel (3.106ubuntu3) kinetic; urgency=medium

  [ Ethan Hsieh ]

  * Add ZCU111 support (LP: #1978798)
  * bootscr.zynqmp (LP: #1978798)
    - Improve messaging in U-Boot boot script for board detection
    - Add kria and zcu board support lists
    - Update kR260 and KV260's bootargs as per AMD-Xilinx's request
    - Support legacy KV260 U-Boot

  [ Alexandre Ghiti ]

  * Allow to bypass container exit test by introducing FK_FORCE_CONTAINER
    for RISC-V images build to run flash-kernel in a container (LP: #1980929)

 -- Dave Jones <dave.jones@canonical.com>  Thu, 14 Jul 2022 13:19:57 +0100

flash-kernel (3.106ubuntu2) kinetic; urgency=medium

  * db/all.db: add dummy entry for RISC-V under QEMU (LP: #1980519)

 -- Dave Jones <dave.jones@canonical.com>  Wed, 06 Jul 2022 11:25:53 +0100

flash-kernel (3.106ubuntu1) kinetic; urgency=medium

  [ Dave Jones ]

  * Merge from Debian unstable (LP: #1973801). Remaining changes:
    - Add support for QCT APQ8064 CDP
      - Add support for QCT APQ8064 CDP; thanks Alfonso Sanchez-Beato.
    - Add support for Calxeda Highbank
      - Add support for Calxeda Highbank (with bootscr.highbank different from
        Debian's version)
      - bootscr.highbank: allow more space to load larger kernels
    - Add support for Nexus 4 (Mako)
      - Enabling support for mako (Nexus 4)
    - Add support for Marvell ArmadaXP
      - Re-add support for Marvell ArmadaXP
      - Fix armadaxp kernel load address
    - Add support for Samsung Exynos 5440 platforms
      - Add support for EXYNOS5440-based platforms
    - Add generic-lpae to the XB-Subarchitecture list in debian/control
    - debian/flash-kernel-installer.isinstallable: add arm*/generic-lpae
    - Add support for HP ProLiant m400 cartridges
      - Add support for HP ProLiant m400 Server Cartridges
      - HP Moonshot Cartridges: Use $baudrate from u-boot environment as
        serial console speed
      - HP Moonshot Cartridges: Enable hardware flow control as required by
        the HP moonshot chassis
      - Enable U-Boot environment support for X-Gene platforms
      - Use filesystem agnostic "load" command instead of assuming ext4
      - Add a bootscript specific to X-Gene Mustang boards since they need to
        pull their dtb from the OS.
    - Add support for OMAP3 and OMAP4 boards
      - add DB entry for "OMAP3 Beagle Board" (funnily thats missing)
      - add Panda to the list of supported board in the README file
      - debian/control: Re-add omap and omap4 to the flash-kernel-installer
        XB-Subarchitecture field. These appear to have been lost somewhere
        along the way.
      - Also add omap and omap4 to flash-kernel-installer.isinstallable.
      - switch omap3 and omap4 to uEnv.txt/preEnv.txt (the former holds all
        active boot commands, the latter holds the kernel commandline only)
      - switch omap3 and omap4 from Bootloader-sets-root: no to yes, we now
        generate a root=UUID= line on the fly for arches using
        uEnv.txt/preEnv.txt
      - introduce bootscript/uEnvtxt.omap
      - do not move the original uEnvtxt.omap to the target, use a copy
        instead
      - add "quiet splash" as default options to omap bootscr
    - enable UUID detection of the currently used root device
    - if uEnv.txt is defined in the db for an arch, generate preEnv.txt from
      UBOOT_DEFAULTS and UUID detection data
    - make sure blkid only gives us the UUID and not any other metadata like
      labels or filesystem
    - hide the boot device from udisk's automounting after installation on all
      systems using uEnv.txt to configure u-boot
    - make sure we only rename the bootrom partition so udisks hides it, when
      using mkdosfs for setting the label like we did in jasper (where we
      cached the contents before doing this) MLO and u-boot.bin are gone
    - Add support for grouper boards
      - add support for the grouper architecture
    - db/all.db: add dummy entries as noops when running on VMs
    - Add support for Wandboard Quad
      - Wandboard: Use /dev/disk/by-path/platform-2198000.usdhc-part1 instead
        of the hardcoded mmcblk1p1, this should make things work on boards
        with just a single microSD card in.
      - Add basic support for WandBoard Quad.
    - Add support for AAarch64 Qualcomm laptops.
      - Fix AARCH64 qcom laptop names, to those accepted upstream and in the
        Ubuntu kernel.
    - Add support for Raspberry Pi 2, 3, 3+, CM3, CM3+, and 4 using a unified
      bootscript (replaces upstream's entries)
      - Update pi bootscript to support all flash-kernel vars, including
        calculated devtype and partition for future USB boot support
      - Install all potential uboot scripts [previously undocumented]
      - Add entry for Raspberry Pi 3A+
      - Add entry for Raspberry Pi CM4
      - Add entry for Raspberry Pi 400
      - Import UC20 updates to the rpi bootscript from the snappy-dev/image
        PPA
    - Add Kernel-Flavors check to Raspberry Pi entries
      - Support "raspi" kernel flavor
    - make sure that if we dont want to override the bootloader root= option
      by setting "Bootloader-sets-root: yes", we actually dont do it
    - Update tests with new fields: Bootloader-sets-root
    - use umount -l in the cleanup function, else we fail while finishing up
      with the script
    - add a diversion for update-initramfs to live-installers post-base-
      installer.d to avoid update-initramfs runs before flash-kernel is
      configured
    - add a check for the diverted update-initramfs to flash-kernel-installer,
      so it gets reverted before we try to call update-initramfs
    - make post-base-installer.d/01flash-kernel-diversion actually an
      executable shell script
    - make sure that /dev is bind mounted in /target when running update-
      initramfs from flash-kernel-installer, else we do not find the boot
      media (this is only a workaround, actual fixing of the netinst
      environment is needed to fix this properly)
    - drop the "|| true" from the initramfs building code, if we fail here we
      actually dont want to attempt to flash that
    - Do not run flash-kernel inside an LXC container
    - Migrate default /etc/default/flash-kernel content to new default without
      asking via debconf
    - Filter the selection of 'latest' usable kernel through the whitelist.
    - Do not fail if there are no specified Kernel-Flavors for this machine.
    - flash-kernel/functions: Stop attempting to install the latest kernel if
      we request an older version, just refuse to act without --force.
    - Look for dtbs in /lib/firmware/$kvers/device-tree/ in find_dtb_file()
    - Allow us to find DTBs in both the old flat layout and the new vendor
      subdirectory layout, so we keep backward compatibility
    - Add support for gzip-compressed kernel images
    - Fix mkimage_kernel tests
    - Add tests for android-related functions
    - Add "pi" value for the "Method" field which copies all dtbs and overlays
      to the boot partition and provides defaults for the boot paths of the
      kernel, initrd, and u-boot script.
      - This fixes upgrades to support the Pi 4 on Bionic
      - Permit initrd to be missing in flash-kernel
      - Make U-boot optional in the "pi" method. From Groovy onwards, U-Boot
        will be an option in the boot chain but not activated by default. For
        the time being, the U-Boot-Script-Name will remain in the Pi entries,
        but this commit permits it to be blank in future.
      - Copy the Pi's bootloader firmware. At present, the Pi's bootloader
        firmware is being copied to the boot partition by the postinst of the
        linux-firmware-raspi2 package. However, flash-kernel should be
        responsible for copying *everything* necessary to boot the Linux
        kernel, hence this responsibility should be transferred to flash-
        kernel.
    - Ensure tests work independently of sort implementation
    - Always run flash-kernel on install/upgrade
    - Add pattern matching for machines
      - A requirement has come up to permit a simple form of pattern matching
        (specifically shell-style globbing) in the Machine field of the
        database. This commit implements this via a "case" match.
    - Add workaround for older u-boot versions that can fail to read files
      using ext4 extents, and enable it for HP ProLiant m400 Moonshot Server
      Cartridges.
    - Make errors in workaround for HP Proliant m400 u-boot ext4 parsing bug
      fatal.
    - Install u-boot binaries in addition to u-boot scripts for the Pi
    - Copy overlay_map.dtb into overlays/ sub-directory instead of the root of
      the boot partition
    - Add minor board revisions to db/all.db
    - Add support for FIT images
      - Support for ITS files
      - New Boot-FIT-Path and Boot-ITS-File-Name DB fields
    - Add Xilinx Kria SOM and ZCU10{2,4,6} boards to the devices database
    - Drop the "systemd.gpt_auto=0 rd.systemd.unit=basic.target" values from
      the snapd_standard_params, which have not been needed since pre-GA of
      UC20 and were removed in pc gadget on 20th April 2020.
    - Introduce "Boot-Kernel-Max-Size" and support for compressing kernel
      images that exceed it. This will allow installation of larger
      uncompressed kernels on HP ProLiant m400 cartridges.
    - mkimage_fit: subst KERNEL_VERSION in ITS file with actual kernel
      version.
    - Add DB entry, bootscript and ITS templates for Mediatek AIoT i500 board.
    - Cache lookup of Bootloader-Has-Broken-Ext4-Extent-Support for
      significant performance improvement on Raspberry Pi
    - Added note in db/all.db above Pi entries about "incorrect" DTB-Id
    - Add raspi-nolpae kernel flavor to all supported boards
    - Added entries for the Pi 4B rev 1.5, and moved CM4 and 400 models to
      their own entries for the sake of clarity
    - Include overlays/README in the files copied by Method: pi
    - Add Kria KR260 support
    - bootscr.zynqmp:
      - Add Kria KV260 support on jammy and kinetic
      - Add ZCU102/104/106 support on jammy and kinetic
    - image-kria.its: add dtb files into fitimage
    - Add kernel parameter for Kria TSN
  * Removed obsolete patches/changes:
    - Remove raspi2 flavour
      - The raspi2 flavour does not exist in Groovy onwards
  * Removed patches obsoleted/merged by upstream:
    - Cherry-pick patch from Debian to disable flash-kernel on EFI-based
      systems.
    - Add riscv64 support
    - Add the following boards to db/all.db
      - SiFive HiFive Unmatched A00
      - BeagleV Starlight Beta

  [ Alexandre Ghiti ]

  * Add StarFive VisionFive board to the database
  * Add support for VisionFive, Nezha and LicheeRV boards

 -- Dave Jones <dave.jones@canonical.com>  Tue, 17 May 2022 17:58:28 +0100

flash-kernel (3.106) unstable; urgency=medium

  * db/all.db: Move MNT Reform 2 boards later to fix sort order.

 -- Vagrant Cascadian <vagrant@debian.org>  Fri, 22 Apr 2022 16:55:41 -0700

flash-kernel (3.105) unstable; urgency=medium

  [ Matthias Klose ]
  * Allow building without the udeb package. (Closes: #983498)

  [ Heinrich Schuchardt ]
  * all.db: add support for ODROID-C4, -HC4, -N2, -N2Plus (Closes: #982369)

  [ Date Huang ]
  * functions: skip flash-kernel in all EFI system

  [ Henry-Nicolas Tourneur ]
  * Add Librem5r4 (Evergreen).

  [ Heinrich Schuchardt ]
  * bootscript: unify generic boot scripts
  * db/all.db: add SiFive HiFive Unmatched A00 (Closes: #1006926)
  * debian/control: enable building for riscv64
  * db: add BeagleV Starlight Beta board to the database

  [ Vagrant Cascadian ]
  * functions: Use dpkg --print-architecture to determine architecture.

  [ Heinrich Schuchardt ]
  * db: add Microchip PolarFire-SoC Icicle Kit to the database

  [ Johannes Schauer Marin Rodrigues ]
  * Add MNT Reform 2

  [ Vagrant Cascadian ]
  * debian/control: Update Standards Version to 4.6.0, no changes.

 -- Vagrant Cascadian <vagrant@debian.org>  Fri, 22 Apr 2022 12:26:15 -0700

flash-kernel (3.104ubuntu10) kinetic; urgency=medium

  * Add Kria KR260 support
  * bootscr.zynqmp:
    - Add Kria KV260 support on jammy and kinetic
    - Add ZCU102/104/106 support on jammy and kinetic
  * image-kria.its: add dtb files into fitimage
  * Add kernel parameter for Kria TSN

 -- Ethan Hsieh <ethan.hsieh@canonical.com>  Thu, 21 Apr 2022 12:38:21 +0800

flash-kernel (3.104ubuntu9) jammy; urgency=medium

  * Cache lookup of Bootloader-Has-Broken-Ext4-Extent-Support for significant
    performance improvement on Raspberry Pi (LP: #1965129)
  * Added note in db/all.db above Pi entries about "incorrect" DTB-Id
    (LP: #1928314)
  * Add raspi-nolpae kernel flavor to all supported boards (LP: #1962312)
  * Added entries for the Pi 4B rev 1.5, and moved CM4 and 400 models to their
    own entries for the sake of clarity
  * Include overlays/README in the files copied by Method: pi

 -- Dave Jones <dave.jones@canonical.com>  Mon, 18 Apr 2022 12:13:13 +0100

flash-kernel (3.104ubuntu8) jammy; urgency=medium

  * mkimage_fit: subst KERNEL_VERSION in ITS file with actual kernel
    version.
  * Add DB entry, bootscript and ITS templates for Mediatek AIoT i500 board.

 -- Ethan Hsieh <ethan.hsieh@canonical.com>  Sun, 03 Apr 2022 19:33:03 +0200


flash-kernel (3.104ubuntu7) jammy; urgency=medium

  * Add riscv64 support (LP: #1966219)
  * Add the following boards to db/all.db
    - SiFive HiFive Unmatched A00 
    - BeagleV Starlight Beta

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Tue, 08 Mar 2022 10:05:15 +0100

flash-kernel (3.104ubuntu6) jammy; urgency=medium

  * Introduce "Boot-Kernel-Max-Size" and support for compressing kernel
    images that exceed it. This will allow installation of larger
    uncompressed kernels on HP ProLiant m400 cartridges. LP: #1954692
  * Drop support for HP ProLiant m800 cartridges. The kernel flavor they
    require (-keystone) never shipped in Ubuntu.

 -- dann frazier <dannf@ubuntu.com>  Mon, 31 Jan 2022 16:47:18 +0000

flash-kernel (3.104ubuntu5) impish; urgency=medium

  * Drop the "systemd.gpt_auto=0 rd.systemd.unit=basic.target" values from
    the snapd_standard_params, which have not been needed since pre-GA of
    UC20 and were removed in pc gadget on 20th April 2020. LP: #1933093

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 21 Jun 2021 12:12:21 +0100

flash-kernel (3.104ubuntu4) impish; urgency=medium

  [ Alfonso Sanchez-Beato ]
  * Add support for FIT images
    - Support for ITS files
    - New Boot-FIT-Path and Boot-ITS-File-Name DB fields
  * Add Xilinx Kria SOM and ZCU10{2,4,6} boards to the devices database

 -- Loïc Minier <loic.minier@ubuntu.com>  Mon, 14 Jun 2021 17:47:16 +0200

flash-kernel (3.104ubuntu3) hirsute; urgency=medium

  * Copy overlay_map.dtb into overlays/ sub-directory instead of the
    root of the boot partition (LP: #1918110)
  * Add minor board revisions to db/all.db

 -- Dave Jones <dave.jones@canonical.com>  Tue, 06 Apr 2021 11:31:11 +0100

flash-kernel (3.104ubuntu2) hirsute; urgency=medium

  * Cherry-pick patch from Debian to disable flash-kernel on EFI-based
    systems. LP: #1920827.

 -- dann frazier <dannf@ubuntu.com>  Mon, 22 Mar 2021 15:21:53 -0600

flash-kernel (3.104ubuntu1) hirsute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Add support for QCT APQ8064 CDP
      - Add support for QCT APQ8064 CDP; thanks Alfonso Sanchez-Beato.
    - Add support for Calxeda Highbank
      - Add support for Calxeda Highbank (with bootscr.highbank different from
        Debian's version)
      - bootscr.highbank: allow more space to load larger kernels
    - Add support for Nexus 4 (Mako)
      - Enabling support for mako (Nexus 4)
    - Add support for Marvell ArmadaXP
      - Re-add support for Marvell ArmadaXP
      - Fix armadaxp kernel load address
    - Add support for Samsung Exynos 5440 platforms
      - Add support for EXYNOS5440-based platforms
    - Add generic-lpae to the XB-Subarchitecture list in debian/control
    - debian/flash-kernel-installer.isinstallable: add arm*/generic-lpae
    - Add support for HP ProLiant m400 and m800 cartridges
      - Added support for HP ProLiant m800 Server Cartridge
      - Add support for HP ProLiant m800 cartridges
      - Set required boot arguments for HP ProLiant m800 cartridges
      - Add support for HP ProLiant m400 Server Cartridges
      - HP Moonshot Cartridges: Use $baudrate from u-boot environment as
        serial console speed
      - HP Moonshot Cartridges: Enable hardware flow control as required by
        the HP moonshot chassis
      - Enable U-Boot environment support for X-Gene platforms
      - Use filesystem agnostic "load" command instead of assuming ext4
      - Add a bootscript specific to X-Gene Mustang boards since they need to
        pull their dtb from the OS.
    - Add support for OMAP3 and OMAP4 boards
      - add DB entry for "OMAP3 Beagle Board" (funnily thats missing)
      - add Panda to the list of supported board in the README file
      - debian/control: Re-add omap and omap4 to the flash-kernel-installer
        XB-Subarchitecture field. These appear to have been lost somewhere
        along the way.
      - Also add omap and omap4 to flash-kernel-installer.isinstallable.
      - switch omap3 and omap4 to uEnv.txt/preEnv.txt (the former holds all
        active boot commands, the latter holds the kernel commandline only)
      - switch omap3 and omap4 from Bootloader-sets-root: no to yes, we now
        generate a root=UUID= line on the fly for arches using
        uEnv.txt/preEnv.txt
      - introduce bootscript/uEnvtxt.omap
      - do not move the original uEnvtxt.omap to the target, use a copy
        instead
      - add "quiet splash" as default options to omap bootscr
    - enable UUID detection of the currently used root device
    - if uEnv.txt is defined in the db for an arch, generate preEnv.txt from
      UBOOT_DEFAULTS and UUID detection data
    - make sure blkid only gives us the UUID and not any other metadata like
      labels or filesystem
    - hide the boot device from udisk's automounting after installation on all
      systems using uEnv.txt to configure u-boot
    - make sure we only rename the bootrom partition so udisks hides it,
      when using mkdosfs for setting the label like we did in jasper (where
      we cached the contents before doing this) MLO and u-boot.bin are gone
    - Add support for grouper boards
      - add support for the grouper architecture
    - db/all.db: add dummy entries as noops when running on VMs
    - Add support for Wandboard Quad
      - Wandboard: Use /dev/disk/by-path/platform-2198000.usdhc-part1
        instead of the hardcoded mmcblk1p1, this should make things work on
        boards with just a single microSD card in.
      - Add basic support for WandBoard Quad.
    - Add support for AAarch64 Qualcomm laptops.
      - Fix AARCH64 qcom laptop names, to those accepted upstream and in the
        Ubuntu kernel.
    - Add support for Raspberry Pi 2, 3, 3+, CM3, CM3+, and 4 using a
      unified bootscript (replaces upstream's entries)
      - Update pi bootscript to support all flash-kernel vars, including
        calculated devtype and partition for future USB boot support
      - Install all potential uboot scripts [previously undocumented]
      - Add entry for Raspberry Pi 3A+
      - Add entry for Raspberry Pi CM4
      - Add entry for Raspberry Pi 400
      - Import UC20 updates to the rpi bootscript from the snappy-dev/image
        PPA
    - Add Kernel-Flavors check to Raspberry Pi entries
      - Support "raspi" kernel flavor in addition to "raspi2"
    - Remove raspi2 flavour
      - The raspi2 flavour does not exist in Groovy onwards
    - make sure that if we dont want to override the bootloader root=
      option by setting "Bootloader-sets-root: yes", we actually dont do it
    - Update tests with new fields: Bootloader-sets-root
    - use umount -l in the cleanup function, else we fail while finishing up
      with the script
    - add a diversion for update-initramfs to live-installers
      post-base-installer.d to avoid update-initramfs runs before flash-kernel
      is configured
    - add a check for the diverted update-initramfs to flash-kernel-installer,
      so it gets reverted before we try to call update-initramfs
    - make post-base-installer.d/01flash-kernel-diversion actually an
      executable shell script
    - make sure that /dev is bind mounted in /target when running
      update-initramfs from flash-kernel-installer, else we do not find the
      boot media (this is only a workaround, actual fixing of the netinst
      environment is needed to fix this properly)
    - drop the "|| true" from the initramfs building code, if we fail here we
      actually dont want to attempt to flash that
    - Do not run flash-kernel inside an LXC container
    - Migrate default /etc/default/flash-kernel content to new default without
      asking via debconf
    - Filter the selection of 'latest' usable kernel through the whitelist.
    - Do not fail if there are no specified Kernel-Flavors for this machine.
    - flash-kernel/functions: Stop attempting to install the latest kernel
      if we request an older version, just refuse to act without --force.
    - Look for dtbs in /lib/firmware/$kvers/device-tree/ in find_dtb_file()
    - Allow us to find DTBs in both the old flat layout and the new vendor
      subdirectory layout, so we keep backward compatibility
    - Add support for gzip-compressed kernel images
    - Fix mkimage_kernel tests
    - Add tests for android-related functions
    - Add "pi" value for the "Method" field which copies all dtbs and
      overlays to the boot partition and provides defaults for the boot
      paths of the kernel, initrd, and u-boot script.
      - This fixes upgrades to support the Pi 4 on Bionic
      - Permit initrd to be missing in flash-kernel
      - Make U-boot optional in the "pi" method. From Groovy onwards, U-Boot
        will be an option in the boot chain but not activated by default.
        For the time being, the U-Boot-Script-Name will remain in the Pi
        entries, but this commit permits it to be blank in future.
      - Copy the Pi's bootloader firmware. At present, the Pi's bootloader
        firmware is being copied to the boot partition by the postinst of
        the linux-firmware-raspi2 package. However, flash-kernel should be
        responsible for copying *everything* necessary to boot the Linux
        kernel, hence this responsibility should be transferred to
        flash-kernel.
    - Always run flash-kernel on install/upgrade
    - Add pattern matching for machines
      - A requirement has come up to permit a simple form of pattern matching
        (specifically shell-style globbing) in the Machine field of the
        database. This commit implements this via a "case" match.
    - Ensure tests work independently of sort implementation
    - Add workaround for older u-boot versions that can fail to read files
      using ext4 extents, and enable it for HP ProLiant m400 Moonshot Server
      Cartridges.
    - Make errors in workaround for HP Proliant m400 u-boot ext4 parsing bug
      fatal.
  * Install u-boot binaries in addition to u-boot scripts for the Pi

 -- Dave Jones <dave.jones@canonical.com>  Thu, 18 Feb 2021 12:06:26 +0000

flash-kernel (3.104) unstable; urgency=medium

  [ Guido Günther ]
  * functions: Tell user which platform is unsupported

  [ harry88 ]
  * Add support for Orange Pi One Plus (Closes: #981328).

  [ Jiri Kastner ]
  * Adding ROCK pi 4 (A,B,C)

  [ Andre Heider ]
  * Add missing ESPRESSObin variants (Closes: #969518)

  [ Vagrant Cascadian ]
  * all.db: Fix several DTB-Id entries that incorrectly referenced the
    .dts instead of .dtb file. Thanks to harry88.
  * Add support for Banana Pi BPI-M2-Ultra. Thanks to Bernhard.
    (Closes: #982089)
  * Add support for Banana Pi BPI-M3.  Thanks to Bernhard.
    (Closes: #981561)
  * Update to debhelper-compat 13.
  * Drop explicit setting of DEB_HOST_ARCH, should be set by dpkg.
  * debian/triggers: use noawait variant.
  * Update Standards-Version to 4.5.1, no changes needed.

 -- Vagrant Cascadian <vagrant@debian.org>  Sat, 06 Feb 2021 19:42:01 -0800

flash-kernel (3.103ubuntu2) hirsute; urgency=medium

  * Make errors in workaround for HP Proliant m400 u-boot ext4 parsing
    bug fatal. LP: #1915078.

 -- dann frazier <dannf@ubuntu.com>  Mon, 08 Feb 2021 17:54:06 -0700

flash-kernel (3.103ubuntu1) hirsute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Add support for QCT APQ8064 CDP
      - Add support for QCT APQ8064 CDP; thanks Alfonso Sanchez-Beato.
    - Add support for Calxeda Highbank
      - Add support for Calxeda Highbank (with bootscr.highbank different
        from Debian's version)
      - bootscr.highbank: allow more space to load larger kernels
    - Add support for Nexus 4 (Mako)
      - Enabling support for mako (Nexus 4)
    - Add support for Marvell ArmadaXP
      - Re-add support for Marvell ArmadaXP
      - Fix armadaxp kernel load address
    - Add support for Samsung Exynos 5440 platforms
      - Add support for EXYNOS5440-based platforms
    - Add generic-lpae to the XB-Subarchitecture list in debian/control
      - debian/flash-kernel-installer.isinstallable: add arm*/generic-lpae
    - Add support for HP ProLiant m400 and m800 cartridges
      - Added support for HP ProLiant m800 Server Cartridge
      - Add support for HP ProLiant m800 cartridges
      - Set required boot arguments for HP ProLiant m800 cartridges
      - Add support for HP ProLiant m400 Server Cartridges
      - HP Moonshot Cartridges: Use $baudrate from u-boot environment as
        serial console speed
      - HP Moonshot Cartridges: Enable hardware flow control as required by
        the HP moonshot chassis
      - Enable U-Boot environment support for X-Gene platforms
      - Use filesystem agnostic "load" command instead of assuming ext4
      - Add a bootscript specific to X-Gene Mustang boards since they need to
        pull their dtb from the OS.
    - Add support for OMAP3 and OMAP4 boards
      - add DB entry for "OMAP3 Beagle Board" (funnily thats missing)
      - add Panda to the list of supported board in the README file
      - debian/control: Re-add omap and omap4 to the flash-kernel-installer
        XB-Subarchitecture field. These appear to have been lost somewhere
        along the way.
      - Also add omap and omap4 to flash-kernel-installer.isinstallable.
      - switch omap3 and omap4 to uEnv.txt/preEnv.txt (the former holds all
        active boot commands, the latter holds the kernel commandline only)
      - switch omap3 and omap4 from Bootloader-sets-root: no to yes, we now
        generate a root=UUID= line on the fly for arches using
        uEnv.txt/preEnv.txt
      - introduce bootscript/uEnvtxt.omap
      - do not move the original uEnvtxt.omap to the target, use a copy
        instead
      - add "quiet splash" as default options to omap bootscr
      - enable UUID detection of the currently used root device
      - if uEnv.txt is defined in the db for an arch, generate preEnv.txt
        from UBOOT_DEFAULTS and UUID detection data
      - make sure blkid only gives us the UUID and not any other metadata
        like labels or filesystem
      - hide the boot device from udisk's automounting after installation
        on all systems using uEnv.txt to configure u-boot
      - make sure we only rename the bootrom partition so udisks hides it,
        when using mkdosfs for setting the label like we did in jasper
        (where we cached the contents before doing this) MLO and u-boot.bin
        are gone
    - Add support for grouper boards
      - add support for the grouper architecture
    - db/all.db: add dummy entries as noops when running on VMs
    - Add support for Wandboard Quad
      - Wandboard: Use /dev/disk/by-path/platform-2198000.usdhc-part1 instead
        of the hardcoded mmcblk1p1, this should make things work on boards
        with just a single microSD card in.
      - Add basic support for WandBoard Quad.
    - Add support for AAarch64 Qualcomm laptops.
      - Fix AARCH64 qcom laptop names, to those accepted upstream and in the
        Ubuntu kernel. LP: #1847594
    - Add support for Raspberry Pi 2, 3, 3+, CM3, CM3+, and 4 using a
      unified bootscript (replaces upstream's entries)
      - Update pi bootscript to support all flash-kernel vars, including
        calculated devtype and partition for future USB boot support
      - Install all potential uboot scripts [previously undocumented]
      - Add entry for Raspberry Pi 3A+ (LP: #1841955)
      - Add entry for Raspberry Pi CM4
      - Add entry for Raspberry Pi 400
      - Import UC20 updates to the rpi bootscript from the snappy-dev/image
        PPA (LP: #1871831)
    - Add Kernel-Flavors check to Raspberry Pi entries
      - Support "raspi" kernel flavor in addition to "raspi2" (LP: #1868071)
    - Remove raspi2 flavour
      - The raspi2 flavour does not exist in Groovy onwards
    - make sure that if we dont want to override the bootloader root=
      option by setting "Bootloader-sets-root: yes", we actually dont do it
      - Update tests with new fields: Bootloader-sets-root
    - use umount -l in the cleanup function, else we fail while finishing
      up with the script
    - add a diversion for update-initramfs to live-installers
      post-base-installer.d to avoid update-initramfs runs before
      flash-kernel is configured
      - add a check for the diverted update-initramfs to
        flash-kernel-installer, so it gets reverted before we try to call
        update-initramfs
      - make post-base-installer.d/01flash-kernel-diversion actually an
        executable shell script
    - make sure that /dev is bind mounted in /target when running
      update-initramfs from flash-kernel-installer, else we do not find the
      boot media (this is only a workaround, actual fixing of the netinst
      environment is needed to fix this properly)
      - drop the "|| true" from the initramfs building code, if we fail here
        we actually dont want to attempt to flash that
    - Do not run flash-kernel inside an LXC container
    - Migrate default /etc/default/flash-kernel content to new default
      without asking via debconf
    - Filter the selection of 'latest' usable kernel through the whitelist.
      - Do not fail if there are no specified Kernel-Flavors for this
        machine.
    - flash-kernel/functions: Stop attempting to install the latest kernel
      if we request an older version, just refuse to act without --force.
    - Look for dtbs in /lib/firmware/$kvers/device-tree/ in find_dtb_file()
      - Allow us to find DTBs in both the old flat layout and the new vendor
        subdirectory layout, so we keep backward compatibility
    - Add support for gzip-compressed kernel images
    - Fix mkimage_kernel tests
    - Add tests for android-related functions
    - Add "pi" value for the "Method" field which copies all dtbs and
      overlays to the boot partition and provides defaults for the boot
      paths of the kernel, initrd, and u-boot script.
      - This fixes upgrades to support the Pi 4 on Bionic (LP: #1850678)
      - Permit initrd to be missing in flash-kernel (LP: #1867791)
      - Make U-boot optional in the "pi" method. From Groovy onwards, U-Boot
        will be an option in the boot chain but not activated by default. For
        the time being, the U-Boot-Script-Name will remain in the Pi entries,
        but this commit permits it to be blank in future.
      - Copy the Pi's bootloader firmware. At present, the Pi's bootloader
        firmware is being copied to the boot partition by the postinst of the
        linux-firmware-raspi2 package. However, flash-kernel should be
        responsible for copying *everything* necessary to boot the Linux
        kernel, hence this responsibility should be transferred to
        flash-kernel.
    - Always run flash-kernel on install/upgrade
    - Add pattern matching for machines
      - A requirement has come up to permit a simple form of pattern matching
        (specifically shell-style globbing) in the Machine field of the
        database. This commit implements this via a "case" match.
    - Ensure tests work independently of sort implementation
    - Add workaround for older u-boot versions that can fail to read files
      using ext4 extents, and enable it for HP ProLiant m400 Moonshot Server
      Cartridges. LP: #1900796

  * Added entry for RPi 400 to db/all.db (previously implied by the Raspberry
    Pi wildcard entry)
  * Ensured tests run successfully regardless of the "sort" implementation

 -- Dave Jones <dave.jones@canonical.com>  Sun, 22 Nov 2020 15:32:05 +0000

flash-kernel (3.103) unstable; urgency=medium

  * Team upload

  [ Updated translations ]
  * Basque (eu.po) by Iñaki Larrañaga Murgoitio

  [ New translations ]
  * Kabyle (kab.po) by Slimane Selyan Amiri
  * Occitan (oc.po) by Quentin PAGÈS

 -- Holger Wansing <hwansing@mailbox.org>  Fri, 06 Nov 2020 19:28:09 +0100

flash-kernel (3.102) unstable; urgency=medium

  * Fix FTBFS by sorting db entries.

 -- Vagrant Cascadian <vagrant@debian.org>  Sun, 12 Jul 2020 11:21:40 -0700

flash-kernel (3.101) unstable; urgency=medium

  * Team upload

  [ Heinrich Schuchardt ]
  * Add FriendlyARM NanoPi NEO Plus2. (Closes: #955374)

  [ Vagrant Cascadian ]
  * Add support for Pinebook Pro.

  [ Adam Borowski ]
  * Add support for Pinebook (Closes: #930098)

  [ Sunil Mohan Adapa ]
  * Add entry for Olimex A64-Olinuxino (Closes: #931195)
  * Add entry for Olimex A64-Olinuxino-eMMC (Closes: #931195)

  [ Josua Mayer ]
  * add db entries for SolidRun LX2160A Honeycomb and Clearfog CX.
    (Closes: #958023)
  * Add entries for SolidRun Cubox-i Solo/DualLite variants.
    (Closes: #939261)

  [ Domenico Andreoli ]
  * Add entry for Turris MOX (Closes: #961303)

  [ Holger Wansing ]
  * Remove trailing whitespaces in changelog file, to fix lintian tag.

 -- Holger Wansing <hwansing@mailbox.org>  Sun, 12 Jul 2020 12:42:27 +0200

flash-kernel (3.100ubuntu5) hirsute; urgency=medium

  * Add workaround for older u-boot versions that can fail to read files
    using ext4 extents, and enable it for HP ProLiant m400 Moonshot Server
    Cartridges. LP: #1900796

 -- dann frazier <dannf@ubuntu.com>  Mon, 14 Dec 2020 16:48:14 -0700

flash-kernel (3.100ubuntu4) groovy; urgency=medium

  * Use wild-card matching in check_supported as well as get_machine_field
    (LP: #1899493)

 -- Dave Jones <dave.jones@canonical.com>  Mon, 12 Oct 2020 15:21:57 +0100

flash-kernel (3.100ubuntu3) groovy; urgency=medium

  * Add new Pi models to the database
  * Remove the -raspi2 kernel flavor from the database
  * Add support for pattern matching in the Machine: field of the database
  * For the "pi" method, copy the boot firmware too (relates to LP: #1895137)

 -- Dave Jones <dave.jones@canonical.com>  Wed, 23 Sep 2020 13:14:09 +0100

flash-kernel (3.100ubuntu2) groovy; urgency=medium

  * Import UC20 updates to the rpi bootscript from the snappy-dev/image
    PPA. LP: #1871831

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 15 Jun 2020 14:29:41 +0100

flash-kernel (3.100ubuntu1) groovy; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Add support for QCT APQ8064 CDP
      - Add support for QCT APQ8064 CDP; thanks Alfonso Sanchez-Beato.
    - Add support for Calxeda Highbank
      - Add support for Calxeda Highbank (with bootscr.highbank different from
        Debian's version)
      - bootscr.highbank: allow more space to load larger kernels
    - Add support for Nexus 4 (Mako)
      - Enabling support for mako (Nexus 4)
    - Add support for Marvell ArmadaXP
      - Re-add support for Marvell ArmadaXP
      - Fix armadaxp kernel load address
    - Add support for Samsung Exynos 5440 platforms
      - Add support for EXYNOS5440-based platforms
    - Add generic-lpae to the XB-Subarchitecture list in debian/control
      - debian/flash-kernel-installer.isinstallable: add arm*/generic-lpae
    - Add support for HP ProLiant m400 and m800 cartridges
      - Added support for HP ProLiant m800 Server Cartridge
      - Add support for HP ProLiant m800 cartridges
      - Set required boot arguments for HP ProLiant m800 cartridges
      - Add support for HP ProLiant m400 Server Cartridges
      - HP Moonshot Cartridges: Use $baudrate from u-boot environment as
        serial console speed
      - HP Moonshot Cartridges: Enable hardware flow control as required by
        the HP moonshot chassis
      - Enable U-Boot environment support for X-Gene platforms
      - Use filesystem agnostic "load" command instead of assuming ext4
      - Add a bootscript specific to X-Gene Mustang boards since they need to
        pull their dtb from the OS.
    - Add support for OMAP3 and OMAP4 boards
      - add DB entry for "OMAP3 Beagle Board" (funnily thats missing)
      - add Panda to the list of supported board in the README file
      - debian/control: Re-add omap and omap4 to the flash-kernel-installer
        XB-Subarchitecture field. These appear to have been lost somewhere
        along the way.
      - Also add omap and omap4 to flash-kernel-installer.isinstallable.
      - switch omap3 and omap4 to uEnv.txt/preEnv.txt (the former holds all
        active boot commands, the latter holds the kernel commandline only)
      - switch omap3 and omap4 from Bootloader-sets-root: no to yes, we now
        generate a root=UUID= line on the fly for arches using
        uEnv.txt/preEnv.txt
      - introduce bootscript/uEnvtxt.omap
      - do not move the original uEnvtxt.omap to the target, use a copy
        instead
      - add "quiet splash" as default options to omap bootscr
      - enable UUID detection of the currently used root device
      - if uEnv.txt is defined in the db for an arch, generate preEnv.txt from
        UBOOT_DEFAULTS and UUID detection data
      - make sure blkid only gives us the UUID and not any other metadata like
        labels or filesystem
      - hide the boot device from udisk's automounting after installation on
        all systems using uEnv.txt to configure u-boot
      - make sure we only rename the bootrom partition so udisks hides it,
        when using mkdosfs for setting the label like we did in jasper (where
        we cached the contents before doing this) MLO and u-boot.bin are gone
    - Add support for grouper boards
      - add support for the grouper architecture
    - Add support for Wandboard Quad
      - Wandboard: Use /dev/disk/by-path/platform-2198000.usdhc-part1
        instead of the hardcoded mmcblk1p1, this should make things work on
        boards with just a single microSD card in.
      - Add basic support for WandBoard Quad.
    - Add support for Raspberry Pi 2, 3, 3+, CM3, CM3+, and 4 using a unified
      bootscript (replaces upstream's entries)
      - Update pi bootscript to support all flash-kernel vars, including
        calculated devtype and partition for future USB boot support
      - Install all potential uboot scripts [previously undocumented]
    - db/all.db: Add dummy entries as noops when running on VMs
    - make sure that if we dont want to override the bootloader root=
      option by setting "Bootloader-sets-root: yes", we actually dont do it
    - Update tests with new fields: Bootloader-sets-root
    - use umount -l in the cleanup function, else we fail while finishing up
      with the script
    - add a diversion for update-initramfs to live-installers
      post-base-installer.d to avoid update-initramfs runs before flash-kernel
      is configured
    - add a check for the diverted update-initramfs to flash-kernel-installer,
      so it gets reverted before we try to call update-initramfs
    - make post-base-installer.d/01flash-kernel-diversion actually an
      executable shell script
    - make sure that /dev is bind mounted in /target when running
      update-initramfs from flash-kernel-installer, else we do not find the
      boot media (this is only a workaround, actual fixing of the netinst
      environment is needed to fix this properly)
    - drop the "|| true" from the initramfs building code, if we fail here we
      actually dont want to attempt to flash that
    - Do not run flash-kernel inside an LXC container
    - Migrate default /etc/default/flash-kernel content to new default without
      asking via debconf
    - Filter the selection of 'latest' usable kernel through the whitelist.
    - Do not fail if there are no specified Kernel-Flavors for this machine.
    - flash-kernel/functions: Stop attempting to install the latest kernel
      if we request an older version, just refuse to act without --force.
    - Look for dtbs in /lib/firmware/$kvers/device-tree/ in find_dtb_file()
    - Allow us to find DTBs in both the old flat layout and the new vendor
      subdirectory layout, so we keep backward compatibility
    - Add support for gzip-compressed kernel images
    - Add support for AAarch64 Qualcomm laptops.
      - Fix AARCH64 qcom laptop names, to those accepted upstream and in the
        Ubuntu kernel. LP: #1847594
    - Fix mkimage_kernel tests
    - Add "pi" value for the "Method" field which copies all dtbs and overlays
      to the boot partition and provides defaults for the boot paths of the
      kernel, initrd, and u-boot script. This fixes upgrades to support the Pi
      4 on Bionic (LP: #1850678)
    - Add tests for android-related functions [previously undocumented]
    - Add Kernel-Flavors check to Raspberry Pi entries [previously
      undocumented]
      - Support "raspi" kernel flavor in addition to "raspi2" (LP: #1868071)
    - Add entry for Raspberry Pi 3A+ (LP: #1841955)
    - Always run flash-kernel on install/upgrade
    - Permit initrd to be missing in flash-kernel and the pi u-boot script
      (LP: #1867791)

  * Dropped obsolete changes:
    - Include support for arm*/ixp4xx and arm*/iop32x (was dropped upstream
      but erroneously re-included in prior merge)
    - re-add support for the FLASH_KERNEL_SKIP env variable, so the image
      build infrastructure has a chance to skip the automated flash-kernel run
      during image builds.
    - Also check for FLASH_KERNEL_SKIP to avoid setting up the root parameter
      in case flash-kernel will not be used
    - make the package postinst respect FLASH_KERNEL_SKIP
    - Remove FLASH_KERNEL_SKIP; it's no longer used in livecd-rootfs
    - Add support for installing dtb files in boot partition
    - Remove redundant copying of boot dtb
    - Apply patch from Paolo Pisati for appended DTB support
    - Update tests with new fields: DTB-Kernel-Version
    - Fix typo in dtb_kver test that made it break all non-dtb platforms.
    - Remove redundant DTB-Kernel-Version field (in favour of upstream
      DTB-Append-From field)
    - Merge all RPi bootscripts into one unified bootscript which handles all
      Pi architectures
    - Remove uboot.env case which was only used for RPi2 (now supported by the
      unified RPi bootscript)

 -- Dave Jones <dave.jones@canonical.com>  Mon, 04 May 2020 20:14:16 +0000

flash-kernel (3.100) unstable; urgency=medium

  * Team upload

  [ Uwe Kleine-König ]
  * Add support for bootspec entries (bootable by barebox). (Closes: #931953)
  * Fix a corner case that makes flash-kernel fail silently. (Closes: #932231)
  * Make initrd optional for machines with Boot-Multi-Path. (Adresses:
    #869073)

  [ Guido Günther ]
  * Add support for Librem 5 devkit (Closes: #927700)

  [ Lubomir Rintel]
  * Add support for OLPC XO-1.75 laptops.

  [ Holger Wansing ]
  * Add comment for translators, to keep main menu entry below a 55 columns
    limit. This updates all po|pot files.

  [ Updated translations ]
  * Croatian (hr.po) by gogogogi
  * Marathi (mr.po) by Prachi Joshi

 -- Holger Wansing <hwansing@mailbox.org>  Sat, 01 Feb 2020 07:19:22 +0100

# Older entries have been removed from this changelog.
# To read the complete changelog use `apt changelog flash-kernel`.
